#define GVT_DONT_UNDEF
#include TEST_HEADER
#include <stdio.h>
#include "Testdata.h"

int main()
{
	int err;
	GVT(t) s1, s2;

	GVT(init)(&s1);
	GVT(init)(&s2);

	printf("I u=%d a=%d\n", s1.used, s1.alloced);
	GVT(append_array)(&s2, str10);
	printf("I u=%d a=%d\n", s2.used, s2.alloced);

	/* enlarge from 0 */
	GVT(copy)(&s1, 0, &s2, 4, 3);
	printf("enlarge0 u=%d a=%d " PSTR "\n", s1.used, s1.alloced, s1.array);

	/* overwrite from 1 */
	GVT(copy)(&s1, 1, &s2, 4, 5);
	printf("overwrt1 u=%d a=%d " PSTR "\n", s1.used, s1.alloced, s1.array);

	/* overwrite from 0 */
	GVT(copy)(&s1, 0, &s2, 0, 3);
	printf("overwrt0 u=%d a=%d " PSTR "\n", s1.used, s1.alloced, s1.array);

	/* src trunc */
	GVT(copy)(&s1, 0, &s2, 8, 1000);
	printf("strunc   u=%d a=%d " PSTR "\n", s1.used, s1.alloced, s1.array);

	/* src beyond */
	err = GVT(copy)(&s1, 0, &s2, 10, 10);
	printf("sbeyond  u=%d a=%d " PSTR " %d\n", s1.used, s1.alloced, s1.array, err);


	/* dst beyond */
	err = GVT(copy)(&s1, 8, &s2, 0, 5);
	printf("dbeyond  u=%d a=%d " PSTR " %d\n", s1.used, s1.alloced, s1.array, err);

	/* dst beyond: make visible */
	err = GVT(copy)(&s1, 6, &s2, 8, 2);
	printf("dvisibl  u=%d a=%d " PSTR " %d\n", s1.used, s1.alloced, s1.array, err);


	/* copy all */
	GVT(truncate)(&s1, 0);
	printf("copyall1 u=%d a=%d " PSTR " %d\n", s1.used, s1.alloced, s1.array, err);
	err = GVT(copy)(&s1, 0, &s2, 0, 100);
	printf("copyall2 u=%d a=%d " PSTR " %d\n", s1.used, s1.alloced, s1.array, err);

	/*** copy within the vector ***/

	/* nop-copy */
	GVT(copy)(&s1, 1, &s1, 1, 5);
	printf("nop      u=%d a=%d " PSTR " %d\n", s1.used, s1.alloced, s1.array, err);

	/* overlap */
	GVT(copy)(&s1, 1, &s1, 2, 3);
	printf("overlap1 u=%d a=%d " PSTR " %d\n", s1.used, s1.alloced, s1.array, err);
	GVT(copy)(&s1, 7, &s1, 6, 3);
	printf("overlap2 u=%d a=%d " PSTR " %d\n", s1.used, s1.alloced, s1.array, err);

	GVT(uninit)(&s1);
	GVT(uninit)(&s2);
	return 0;
}
