/* Test copy() */
#include "common.h"

int main()
{
	int err, n;
	GVT(t) a1, a2;

	auto_init(a1);
	auto_init(a2);

	for(n = 0; n < 10; n++)
		GVT(append)(&a2, n);

	printf("I u=%d a=%d\n", a1.used, a1.alloced);
	printf("I u=%d a=%d\n", a2.used, a2.alloced);

	/* enlarge from 0 */
	GVT(copy)(&a1, 0, &a2, 4, 3);
	print_arr("enlarge0", &a1);

	/* overwrite from 1 */
	GVT(copy)(&a1, 1, &a2, 4, 5);
	print_arr("overwrt1", &a1);

	/* overwrite from 0 */
	GVT(copy)(&a1, 0, &a2, 0, 3);
	print_arr("overwrt0", &a1);

	/* src trunc */
	GVT(copy)(&a1, 0, &a2, 8, 1000);
	print_arr("strunc  ", &a1);

	/* src beyond */
	err = GVT(copy)(&a1, 0, &a2, 10, 10);
	print_arr("sbeyond ", &a1);
	printf("err=%d\n", err);


	/* dst beyond */
	err = GVT(copy)(&a1, 8, &a2, 0, 5);
	print_arr("dbeyond ", &a1);

	/* dst beyond: fill the gap */
	err = GVT(copy)(&a1, 6, &a2, 8, 2);
	print_arr("fillgap ", &a1);


	/* copy all */
	GVT(truncate)(&a1, 0);
	print_arr("copyall1", &a1);
	err = GVT(copy)(&a1, 0, &a2, 0, 100);
	print_arr("copyall2", &a1);

	/*** copy within the vector ***/

	/* nop-copy */
	GVT(copy)(&a1, 1, &a1, 1, 5);
	print_arr("nop     ", &a1);

	/* overlap */
	GVT(copy)(&a1, 1, &a1, 2, 3);
	print_arr("overlap1", &a1);
	GVT(copy)(&a1, 7, &a1, 6, 3);
	print_arr("overlap2", &a1);

	GVT(uninit)(&a1);
	GVT(uninit)(&a2);
	return 0;
}
